<script lang="ts">
  import { onMount } from "svelte";
  import { TeamId2025ByUserIdStore } from "$houdini";
  import { authTokenParsed, oidcClient } from "$stores/authStore";
  import { goto } from "$app/navigation";
  import { Alert, Button, Spinner } from "flowbite-svelte";

  const store = new TeamId2025ByUserIdStore();
  $: console.log("team", $store);

  onMount(async () => {
    // require login
    if (!$authTokenParsed) return await $oidcClient.login();
  });

  async function fetchData(userId?: string) {
    if(!userId) throw new Error('Please login before loading your scorecard.')

    await store.fetch({ variables: { userId } });

    if (!($store.data?.teams?.length)) throw new Error("Team not found!");
    else if ($store.data?.teams.length == 1) {
      // If there is just one team, immediately redirect
      const team_id = $store.data.teams[0].id;
      await goto(`/results/2025/teams/${team_id}`);
    }
    return $store.data?.teams
  }
</script>

{#await fetchData($authTokenParsed?.sub)}
  <div class="flex flex-col items-center justify-center m-10">
    <Spinner size="20" />
    <h1 class="text-2xl font-mono font-semibold pt-5">Fetching your Scorecard!</h1>
  </div>
{:then teams}
  <div class="flex flex-col items-center justify-center my-10 mx-auto w-fit">
    <h1 class="text-2xl font-mono font-semibold pt-5">Select your team</h1>
    {#each teams as team}
      <Button class="my-2 w-full" href="/results/2025/teams/{team.id}">{team.name} - {team.long_name}</Button>
    {/each}
  </div>
{:catch error}
  <Alert color="red">
    {error}
  </Alert>
{/await}
